import 'package:flutter/material.dart';

class FullPageStruct extends StatelessWidget {
  final String title;
  final Widget child;
  final Color? color;
  const FullPageStruct({super.key, required this.title, required this.child, this.color});

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(title),
        centerTitle: true,
        leading: IconButton(
          onPressed: () {
            Navigator.pop(context);
          },
          icon: const Icon(Icons.keyboard_arrow_left),
        ),
      ),
      body: child,
      backgroundColor: color,
    );
  }
}
